MOUNT_NFS(8)

NAME
mount_nfs - mount NFS file systems

SYNOPSIS
mount_nfs [-23bcdiLlNPsTU] [-a maxreadahead] [-D deadthresh] [-g maxgroups] [-I readdirsize] [-o options] [-R retrycnt] [-r readsize] [-t timeout] [-w writesize] [-x retrans] rhost:path node

DESCRIPTION
The mount_nfs utility calls the nmount(2) system call to prepare and graft a remote NFS file system (rhost:path) on to the file system tree at the point node. This command is normally executed by mount(8). It implements the mount protocol as described in RFC 1094, Appendix A and Appendix I.

If the file system type is specified as ``oldnfs'', which implies this command is run as ``mount_oldnfs'', then it forces use of the old NFS client, which does not support the nfsv4 option.

By default, mount_nfs keeps retrying until the mount succeeds. This behaviour is intended for file systems listed in fstab(5) that are critical to the boot process. For non-critical file systems, the bg and retrycnt options provide mechanisms to prevent the boot process from hanging if the server is unavailable.

If the server becomes unresponsive while an NFS file system is mounted, any new or outstanding file operations on that file system will hang uninterruptibly until the server comes back. To modify this default behaviour, see the intr and soft options.

The options are:

-o  Options are specified with a -o flag followed by a comma separated string of options. See the mount(8) man page for possible options and their meanings. The following NFS specific options are also available:

    acregmin=<seconds>

    acregmax=<seconds>

    acdirmin=<seconds>

    acdirmax=<seconds>
        When attributes of files are cached, a timeout calculated to determine whether a given cache entry has expired. These four values determine the upper and lower bounds of the timeouts for “directory” attributes and “regular” (ie: everything else). The default values are 3 -> 60 seconds for regular files, and 30 -> 60 seconds for directories. The algorithm to calculate the timeout is based on the age of the file. The older the file, the longer the cache is considered valid, subject to the limits above.

    bg  If an initial attempt to contact the server fails, fork off a child to keep trying the mount in the background. Useful for fstab(5), where the file system mount is not critical to multiuser operation.

    deadthresh=<value>
        Set the “dead server threshold” to the specified number of round trip timeout intervals before a “server not responding” message is displayed.

    dumbtimer
        Turn off the dynamic retransmit timeout estimator. This may be useful for UDP mounts that exhibit high retry rates, since it is possible that the dynamically estimated timeout interval is too short.

    fg  Same as not specifying bg.

    hard
        Same as not specifying soft.

    intr
        Make the mount interruptible, which implies that file system calls that are delayed due to an unresponsive server will fail with EINTR when a termination signal is posted for the process.

    maxgroups=<value>
        Set the maximum size of the group list for the credentials to the specified value. This should be used for mounts on old servers that cannot handle a group list size of 16, as specified in RFC 1057. Try 8, if users in a lot of groups cannot get response from the mount point.

    mntudp
        Force the mount protocol to use UDP transport, even for TCP NFS mounts. (Necessary for some old BSD servers.)

    nametimeo=<value>
        Override the default of NFS_DEFAULT_NAMETIMEO for the timeout (in seconds) for positive name cache entries. If this is set to 0 it disables positive name caching for the mount point.

    negnametimeo=<value>
        Override the default of NFS_DEFAULT_NEGNAMETIMEO for the timeout (in seconds) for negative name cache entries. If this is set to 0 it disables negative name caching for the mount point.

    nfsv2
        Use the NFS Version 2 protocol (the default is to try version 3 first then version 2). Note that NFS version 2 has a file size limit of 2 gigabytes.

    nfsv3
        Use the NFS Version 3 protocol.

    nfsv4
        Use the NFS Version 4 protocol. This option will force the mount to use TCP transport.

    noconn
        For UDP mount points, do not do a connect(2). This must be used if the server does not reply to requests from the standard NFS port number 2049 or replies to requests using a different IP address (which can occur if the server is multi-homed). Setting the vfs.nfs.nfs_ip_paranoia sysctl to 0 will make this option the default.

    nocto
        Normally, NFS clients maintain the close-to-open cache coherency. This works by flushing at close time and checking at open time. Checking at open time is implemented by getting attributes from the server and purging the data cache if they do not match attributes cached by the client.

        This option disables checking at open time. It may improve performance for read-only mounts, but should only be used if the data on the server changes rarely. Be sure to understand the consequences before enabling this option.

    noinet4, noinet6
        Disables AF_INET or AF_INET6 connections. Useful for hosts that have both an A record and an AAAA record for the same name.

    nolockd
        Do not forward fcntl(2) locks over the wire. All locks will be local and not seen by the server and likewise not seen by other NFS clients. This removes the need to run the rpcbind(8) service and the rpc.statd(8) and rpc.lockd(8) servers on the client. Note that this option will only be honored when performing the initial mount, it will be silently ignored if used while updating the mount options.

    principal
        For the RPCSEC_GSS security flavors, such as krb5, krb5i and krb5p, this option sets the name of the host based principal name expected by the server. This option overrides the default, which will be ``nfs@<server-fqdn>'' and should normally be sufficient.

    noresvport
        Do not use a reserved socket port number (see below).

    port=<port_number>
        Use specified port number for NFS requests. The default is to query the portmapper for the NFS port.

    rdirplus
        Used with NFSV3 to specify that the ReaddirPlus RPC should be used. For NFSV4, setting this option has a similar effect, in that it will make the Readdir Operation get more attributes. This option reduces RPC traffic for cases such as “ls -l”, but tends to flood the attribute and name caches with prefetched entries. Try this option and see whether performance improves or degrades. Probably most useful for client to server network interconnects with a large bandwidth times delay product.

    readahead=<value>
        Set the read-ahead count to the specified value. This may be in the range of 0 - 4, and determines how many blocks will be read ahead when a large file is being read sequentially. Trying a value greater than 1 for this is suggested for mounts with a large bandwidth * delay product.

    readdirsize=<value>
        Set the readdir read size to the specified value. The value should normally be a multiple of DIRBLKSIZ that is <= the read size for the mount.

    resvport
        Use a reserved socket port number. This flag is obsolete, and only retained for compatibility reasons. Reserved port numbers are used by default now. (For the rare case where the client has a trusted root account but untrustworthy users and the network cables are in secure areas this does help, but for normal desktop clients this does not apply.)

    retrans=<value>
        Set the retransmit timeout count for soft mounts to the specified value.

    retrycnt=<count>
        Set the mount retry count to the specified value. The default is a retry count of zero, which means to keep retrying forever. There is a 60 second delay between each attempt.

    rsize=<value>
        Set the read data size to the specified value. It should normally be a power of 2 greater than or equal to 1024. This should be used for UDP mounts when the “fragments dropped due to timeout” value is getting large while actively using a mount point. (Use netstat(1) with the -s option to see what the “fragments dropped due to timeout” value is.)

    sec=<flavor>
        This option specifies what security flavor should be used for the mount. Currently, they are:

            krb5 -  Use KerberosV authentication
            krb5i - Use KerberosV authentication and
                    apply integrity checksums to RPCs
            krb5p - Use KerberosV authentication and
                    encrypt the RPC data
            sys -   The default AUTH_SYS, which uses a
                    uid + gid list authenticator

    soft
        A soft mount, which implies that file system calls will fail after retrycnt round trip timeout intervals.

    tcp Use TCP transport. This is the default option, as it provides for increased reliability on both LAN and WAN configurations compared to UDP. Some old NFS servers do not support this method; UDP mounts may be required for interoperability.

    timeout=<value>
        Set the initial retransmit timeout to the specified value. May be useful for fine tuning UDP mounts over internetworks with high packet loss rates or an overloaded server. Try increasing the interval if nfsstat(1) shows high retransmit rates while the file system is active or reducing the value if there is a low retransmit rate but long response delay observed. (Normally, the dumbtimer option should be specified when using this option to manually tune the timeout interval.)

    udp Use UDP transport.

    wcommitsize=<value>
        Set the maximum pending write commit size to the specified value. This determines the maximum amount of pending write data that the NFS client is willing to cache for each file.

    wsize=<value>
        Set the write data size to the specified value. Ditto the comments w.r.t. the rsize option, but using the “fragments dropped due to timeout” value on the server instead of the client. Note that both the rsize and wsize options should only be used as a last ditch effort at improving performance when mounting servers that do not support TCP mounts.

COMPATIBILITY
The following command line flags are equivalent to -o named options and are supported for compatibility with older installations.

-2  Same as -o nfsv2

-3  Same as -o nfsv3

-D  Same as -o deadthresh

-I  Same as -o readdirsize=<value>

-L  Same as -o nolockd

-N  Same as -o noresvport

-P  Use a reserved socket port number. This flag is obsolete, and only retained for compatibility reasons. (For the rare case where the client has a trusted root account but untrustworthy users and the network cables are in secure areas this does help, but for normal desktop clients this does not apply.)

-R  Same as -o retrycnt=<value>

-T  Same as -o tcp

-U  Same as -o mntudp

-a  Same as -o readahead=<value>

-b  Same as -o bg

-c  Same as -o noconn

-d  Same as -o dumbtimer

-g  Same as -o maxgroups

-i  Same as -o intr

-l  Same as -o rdirplus

-r  Same as -o rsize=<value>

-s  Same as -o soft

-t  Same as -o retransmit=<value>

-w  Same as -o wsize=<value>

-x  Same as -o retrans=<value>

SEE ALSO
nmount(2), unmount(2), nfsv4(4), fstab(5), gssd(8), mount(8), nfsd(8), nfsiod(8), showmount(8)

BUGS
Since nfsv4 performs open/lock operations that have their ordering strictly enforced by the server, the options intr and soft cannot be safely used. hard nfsv4 mounts are strongly recommended.